
#include <VarSpeedServo.h>

VarSpeedServo servo;

int buttonPin = 3;
int buttonState = 0;

int max = 180;
int min = 0;
int move = min;
int idle= 90;
int idlespeed = 10;
int wait = 5000;
unsigned long count = 0;
unsigned long time;

void setup ()
{
  Serial.begin(9600);
  servo.attach(9);
  servo.write(idle,idlespeed);
}

void loop ()
{
  buttonState = digitalRead(buttonPin);
  
   while (buttonState==1 && move<max)
   {
    servo.attach(9);
    move=servo.read()+1;
    servo.write(move, idlespeed);
    buttonState = digitalRead(buttonPin);
    count=millis();
      while (buttonState==0)
      {
      buttonState = digitalRead(buttonPin);
      time=millis();
        if (time>count+wait)
        {
        servo.write(idle, idlespeed);
          if(servo.read()==idle)
          {
          servo.detach();
          }
        }
      }
   }  

   while (buttonState==1 && move>min)
   {
            servo.attach(9);
    move=servo.read()-1;
    servo.write(move, idlespeed);
    buttonState = digitalRead(buttonPin);
    count=millis();
      while (buttonState==0)
      {
      buttonState = digitalRead(buttonPin);
      time=millis();
        if (time>count+wait)
        {
        servo.write(idle, idlespeed);
          if(servo.read()==idle)
          {
          servo.detach();
          }
        }
      }
   }
}

