
#include <VarSpeedServo.h>

VarSpeedServo servo;

int joyX = 0;
int hold = 0;
int run=0;
int max = 115;
int min = 90;
int idlespeed = 5;
int manualspeed = 10;
int movetime = 2500;
int wait = 5000;
unsigned long count = 0;
unsigned long time;

int joyVal;
void setup ()
{
  Serial.begin(9600);
  servo.attach(9);
}

void loop ()
{
  
  joyVal = analogRead(joyX);
  
  time = millis();
  count=time+movetime;

   while (joyVal<600 && joyVal>400 && time<count)
   {
    servo.write(min, idlespeed);
    joyVal = analogRead(joyX);
    time = millis();
   }  
     time = millis();
      count=time+movetime;
      
   while (joyVal<600 && joyVal>400 && time<count)
   {
    servo.write(max, idlespeed);
    joyVal = analogRead(joyX);
    time = millis();
       }
    
   while (joyVal>600 || joyVal<400)
  {
    joyVal = map(joyVal, 0, 1023, min, max);
    servo.write(joyVal, manualspeed); //set the servo position acording to the joystick value
    joyVal = analogRead(joyX); 
    hold=servo.read();
      time = millis();
      count=time+wait; 
      
      if(joyVal<600 && joyVal>400)
      {
      servo.write(hold, 1);
        while(joyVal<600 && joyVal>400 && time<count)
        {
        time=millis();
        joyVal = analogRead(joyX); 
        }
      }

  }
}

