
#include <VarSpeedServo.h>

VarSpeedServo servo;

int buttonPinF = 3;
int buttonPinB = 2;
int buttonStateF = 0;
int buttonStateB = 0;

int max = 180;
int min = 0;
int move = min;
int idle= 90;
int movespeed = 10;
int wait = 5000;
unsigned long count = 0;
unsigned long time;

void setup ()
{
  Serial.begin(9600);
  servo.attach(9);
  servo.write(idle,movespeed);
}

void loop ()
{
  buttonStateF = digitalRead(buttonPinF);
  buttonStateB = digitalRead(buttonPinB);
  
   while (buttonStateF==1 && move<max)
   {
    servo.attach(9);
    move=servo.read()+1;
    servo.write(move, movespeed);
    buttonStateF = digitalRead(buttonPinF);
    count=millis();
    
      while (buttonStateF==0&&buttonStateB==0)
      {
      buttonStateF = digitalRead(buttonPinF);
      buttonStateB = digitalRead(buttonPinB);
      time=millis();
      
        if (time>count+wait)
        {
        servo.write(idle, movespeed);
        
          if(servo.read()==idle)
          {
          servo.detach();
          }
        }
      }
   }  

   while (buttonStateB==1 && move>min)
   {
    servo.attach(9);
    move=servo.read()-1;
    servo.write(move, movespeed);
    buttonStateB = digitalRead(buttonPinB);
    count=millis();
    
      while (buttonStateB==0&&buttonStateF==0)
      {
      buttonStateF = digitalRead(buttonPinF);
      buttonStateB = digitalRead(buttonPinB);
      time=millis();
      
        if (time>count+wait)
        {
        servo.write(idle, movespeed);
        
          if(servo.read()==idle)
          {
          servo.detach();
          }
        }
      }
   }
   while (buttonStateB==0&&buttonStateF==0)
      {
      buttonStateF = digitalRead(buttonPinF);
      buttonStateB = digitalRead(buttonPinB);
      time=millis();
      
        if (time>count+wait)
        {
        servo.write(idle, movespeed);
        
          if(servo.read()==idle)
          {
          servo.detach();
          }
        }
      }
}

